<div class="login-wrapper" fxLayout="row" fxLayoutAlign="center center">
  <mat-card class="box">
    <mat-card-header fxLayout="row" fxLayoutAlign="center">
      <mat-card-title>Log In</mat-card-title>
    </mat-card-header>

    <p *ngIf="serverErrorMessage" class="server-error-message">{{serverErrorMessage}}</p>

    <form [formGroup]="myForm" (ngSubmit)="login()" novalidate class="login-form" autocomplete="off">
      <mat-card-content>
        <mat-form-field appearance="outline" class="login-full-width">
          <mat-label>Username</mat-label>
          <input matInput formControlName="username" type="text" name="username" id="username">
          <mat-error *ngIf="errorHandling('username', 'required')">Username is required</mat-error>
        </mat-form-field>

        <mat-form-field appearance="outline" class="login-full-width">
          <mat-label>Password</mat-label>
          <input matInput formControlName="password" type="password" name="password" id="password">
          <mat-error *ngIf="errorHandling('password', 'required')">Password is required</mat-error>
        </mat-form-field>
      </mat-card-content>

      <!-- TODO: how to use 'else' clause -->
      <button *ngIf="!isLoggingIn" mat-flat-button color="primary" class="btn-block">Log In</button>
      <button *ngIf="isLoggingIn" mat-stroked-button color="primary" class="btn-block" disabled>
        <div fxLayout="row" fxLayoutAlign="center center">
          <mat-spinner [diameter]="30" color="accent" ></mat-spinner>
        </div>
      </button>
    </form>
  </mat-card>
</div>